/*******************************************************************************
 * Copyright (c) 2011, Jean-David Gadina - www.xs-labs.com
 * Distributed under the Boost Software License, Version 1.0.
 * 
 * Boost Software License - Version 1.0 - August 17th, 2003
 * 
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 * 
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer,
 * must be included in all copies of the Software, in whole or in part, and
 * all derivative works of the Software, unless such copies or derivative
 * works are solely in the form of machine-executable object code generated by
 * a source language processor.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 ******************************************************************************/

/* $Id: NLUIInstaller.h 245 2010-05-30 14:18:05Z  $ */

/*!
 * @header
 * 
 * @discussion  This file should not be included directly by application source
 *              files using the NutShell framework. Including 'NutShell.h' is
 *              preferred over importing individual files because it will use a
 *              precompiled version.
 */

// Local includes
#import "NLInstaller.h"

/*!
 * @abstract    
 * 
 * @version     1.0
 * @namespace   NutShell
 */
@interface NLUIInstaller: NLInstaller
{
@protected
    
    /*!
     * @abstract    
     */
    BOOL indeterminateProgressForNewPhases;
    
    /*!
     * @abstract    
     */
    BOOL playSoundOnInstallComplete;
    
    /*!
     * @abstract    
     */
    NSSound * completeSound;
    
    /*!
     * @abstract    
     */
    NSTextField * phaseText;
    
    /*!
     * @abstract    
     */
    NSTextField * statusText;
    
    /*!
     * @abstract    
     */
    NSProgressIndicator * progressBar;
    
    /*!
     * @abstract    
     */
    NSButton * installButton;
    
    /*!
     * @abstract    
     */
    NSButton * quitButton;
    
@private
    
    /*!
     * @abstract    Reserved 1
     * 
     * @discussion  Reserved instance variables to help ensure binary
     *              compatibility with future versions of the class.
     */
    id NL_r3 __attribute__( ( unused ) );
    
    /*!
     * @abstract    Reserved 2
     * 
     * @discussion  Reserved instance variables to help ensure binary
     *              compatibility with future versions of the class.
     */
    id NL_r4 __attribute__( ( unused ) );
}

/*! @property */
@property( assign, readwrite ) BOOL indeterminateProgressForNewPhases;

/*! @property */
@property( assign, readwrite ) BOOL playSoundOnInstallComplete;

/*! @property */
@property( copy, readwrite ) NSSound * completeSound;

/*! @property */
@property( assign, readwrite ) NSTextField * phaseText;

/*! @property */
@property( assign, readwrite ) NSTextField * statusText;

/*! @property */
@property( assign, readwrite ) NSProgressIndicator * progressBar;

/*! @property */
@property( assign, readwrite ) NSButton * installButton;

/*! @property */
@property( assign, readwrite ) NSButton * quitButton;

/*!
 * @abstract    
 */
- ( OSStatus )install: ( id )sender;

@end
